Tíquete #44853

Add units to Cimpletoon

: 2022-06-18 11:58 Última Atualização: 2022-11-07 01:05

Relator:
Dono:
Tipo:
Estado:
Fechado
Componente:
Marcos:
Prioridade:
5 - Medium
Gravidade:
5 - Medium
Resolução:
Fixed
Arquivo:
6

Details

Add a some cimpletoon units by XYZ and Elefant.

Ticket History (3/32 Histories)

2022-06-18 11:58 Updated by: elefant
  • New Ticket "Add units to Cimpletoon" created
2022-06-18 12:01 Updated by: elefant
Comentário

Patch attached

2022-06-18 13:57 Updated by: cazfi
Comentário

- You will need to add also the source .blends for the units under data/graphics/cimpletoon/
- For anything that should be installed or made part of freeciv distribution (i.e. not the stuff under data/graphics), you need to update (data/cimpletoon/)Makefile.am for autotools build, and meson.build for Meson based build
- I think you have some extraneous files included (what is null.png?)
- The .spec file you already have in there includes override/flags.spec - I don't think you mean to do that

Don't worry if you can't test the meson build (for example we have a quite high minimum requirement for meson) - just tell that it's untested, and I'll test it for you.

2022-06-18 22:45 Updated by: None
Comentário

Null,png is a blank image, because the program doesn't seem to like it if a spec file only includes files and doesn't have a image of it's own. All the spec files include override/flags.spec because it seems that they must include something. I didn't test build it at all, but I will try to update the Makefiles.

2022-06-18 22:52 Updated by: cazfi
Comentário

Reply To (Anonymous)

Null,png is a blank image, because the program doesn't seem to like it if a spec file only includes files and doesn't have a image of it's own. All the spec files include override/flags.spec because it seems that they must include something.

What are the error messages you are getting when you don't do these things? Neither of these make any sense to me.

Includes are handled by the low-level ini-file handling - it doesn't even know that the file in question has anything to do with graphics (rulesets/savegames/client settings do not).
There's hundreds of top-level ini-files that do not include anything.

2022-06-19 00:34 Updated by: elefant
Comentário

It's been a while since I worked on this but if I remember correctly, the error was that the program expected a field, that was fixed when I added the value include statement. I'll have to take another look at it, though. The error only shows up if there is the (extra) section.

2022-06-20 11:23 Updated by: elefant
Comentário

New patch attached

2022-06-22 19:43 Updated by: cazfi
Comentário

- Please don't add extra units to orient_units.spec corresponding to "standard units". Instead list your new .spec in the main cimpletoon.tilespec.
- As you add SUBDIR to Makefile.am, you have to add the recursive Makefile.am to that subdir + add Makefile.in -> Makefile generation for it to configure.ac.
- Contents of those Readme.txt files seem not to be relevant, but even wrong, in the context that the files are part of freeciv distribution. Leave them out.

2022-07-06 08:52 Updated by: cazfi
Comentário

Any progress?

2022-07-07 03:25 Updated by: elefant
Comentário

Reply To cazfi

Any progress?

Not yet. I was hoping to get the file include structure fixed first. Do you have any ideas on how to do that?

2022-07-09 05:42 Updated by: cazfi
Comentário

Reply To elefant

Not yet. I was hoping to get the file include structure fixed first. Do you have any ideas on how to do that?

I still don't know what's the problem you've been having with the includes not working properly.

2022-07-10 00:06 Updated by: None
Comentário

The includes only include one file (the first one), and ignore all the others. It's possible to just put the spec files for each unit into cimpletoon.tilespec, but that is messy in my opinion.

2022-07-10 00:12 Updated by: cazfi
Comentário

Reply To (Anonymous)

The includes only include one file (the first one), and ignore all the others.

Can you provide a set of files where that happens?

2022-07-10 00:14 Updated by: cazfi
Comentário

Reply To cazfi

Reply To (Anonymous)

The includes only include one file (the first one), and ignore all the others.

Can you provide a set of files where that happens?

Well, preferably open a new ticket about this bug, and attach those files to reproduce it there.

2022-07-21 01:23 Updated by: elefant
Comentário

Added patch. Spec files are now in the tilespec file instead of being included. Set up makefiles.

2022-07-25 11:50 Updated by: cazfi
Comentário

Reply To elefant

Added patch. Spec files are now in the tilespec file instead of being included. Set up makefiles.

- Those .spec files still include override/flags.spec - not only is it unnecessary but can cause everything to break depending on what kind of override the user has
- Leave out those empty "Unit by ???" files. Credits are given in the .spec files
- You need to update configure.ac to have Makefile.in:s generated from all those new Makefile.am:s
- units/xxx.spec is extraneous file, right?

2022-09-21 18:56 Updated by: cazfi
Comentário

Ping. Do you need something from me to go forward?

(Edited, 2022-09-21 18:57 Updated by: cazfi)
2022-09-30 02:41 Updated by: None
Comentário

I am no longer working on this due to time constraints. If someone wants to take over, I have no objections.

2022-10-20 09:32 Updated by: cazfi
  • Marco Update from (Nenhum) to 3.1.0
Comentário

Reply To cazfi

- Leave out those empty "Unit by ???" files. Credits are given in the .spec files

- Also, as those filenames contained spaces, they were causing one of the syntax errors with Makefiles (Files 'Unit', 'by', and 'Elefant' missing)
- For the general avoidance of spaces in paths renamed "XYZ art" and "elefant art" directories under graphics/ to use underscore instead.
- Dropped "Freeciv " from the names of .blends under elefant_art, replaced remaining spaces with underscores.
- Another directory name change was driven by autoconf getting confused by the "m4_" -prefix that it usually reserves for m4 -macros. Didn't bother to figure out how to escape things so that it would work everywhere, but just dropped the underscore
- Some of the xxx.spec files referred to gaphics under "folder" instead of the actual directory name
- Some of the xxx.spec files defined tags with "xxx_" -prefix instead of the actual unit name. I noticed this only because there was more than one of them doing that -> got warnings about duplicate entries
- cimpetoon/units/Makefile.am listed subdirectories by names that ended to comma
- toonhex.tilespec on the othed hand was missing a comma between old files and the newly added ones
- Updated capstr to S3_1 / master one
- Removed extraneous data/cimpletoon/units/panzer_iii/Freeciv\ Panzer\ III.png

- Fixed the issues noticed earlier

Still needs at least Meson side changes.

2022-10-20 09:32 Updated by: cazfi
  • File 0049-Add-units-to-cimpletoon.patch (File ID: 10623) is attached
2022-10-20 17:30 Updated by: cazfi
  • File 0049-Add-units-to-cimpletoon.patch (File ID: 10623) is deleted
2022-10-21 19:12 Updated by: cazfi
Comentário

Reply To cazfi

Still needs at least Meson side changes.

Also, I've not looked if tags are standardized at all - so that all the tilesets with similar "extra units" would provide same tags. Otherwise rulesets using these extra units would work only with one specific tileset that use same tags as the ruleset.

2022-10-29 09:08 Updated by: cazfi
  • File 0034-Add-units-to-cimpletoon.patch.xz (File ID: 10711) is attached
2022-10-29 09:08 Updated by: cazfi
  • File 0034-Add-units-to-cimpletoon.patch.xz (File ID: 10711) is deleted
2022-10-29 09:13 Updated by: cazfi
  • Dono Update from (Nenhum) to cazfi
  • Resolução Update from Nenhum to Accepted
Comentário

- Meson side changes made
- I've not standardized the tags, but to support that I changed order of the columns in the .spec file table (tag | file) -> (file | tag). The idea is that when 'tag' is in the end, it can be treated like a vector; all the excess entries on the row are tags. So we can *add* standard tags (or even multiple)

I think this should now go in. We want to make it available in 3.1, and further improvements can be made in the repository.

2022-11-07 01:05 Updated by: cazfi
  • Estado Update from Aberto to Fechado
  • Resolução Update from Accepted to Fixed

Attachment File List

Editar

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login